import { BrowserContext, ElectronApplication, Page, _electron as electron } from 'playwright';
import { test, expect } from '@playwright/test';
import * as PATH from 'path';

import {Gamesystem} from "../../src/app/project/game-model/gamesystems/Gamesystem";
import {GameModel} from "../../src/app/project/game-model/GameModel";

test.describe('Removing Gamesystems', () => {

  test("Test simple removing of Gamesystems", async () => {
    const gameModel = new GameModel("GameModel");
    const gamesystem = new Gamesystem("Gamesystem");
    gameModel.addGamesystem(gamesystem);

    gameModel.removeGamesystem(gamesystem);
    expect(gameModel.gamesystems.length).toEqual(0);
  })

  test("Test removing of empty gamesystems", async () => {
    const gameModel = new GameModel("GameModel");
    const gamesystem = new Gamesystem("Gamesystem");

    gameModel.removeGamesystem(gamesystem);
    expect(gameModel.gamesystems.length).toEqual(0);
  })
});
