import {Component, Inject, OnInit} from '@angular/core';
import {MAT_DIALOG_DATA, MatDialogRef} from "@angular/material/dialog";
import {InventorySlot} from "../../../../project/game-model/inventory/intentory-slots/InventorySlot";
import {FormControl, Validators} from "@angular/forms";

@Component({
  selector: 'app-inventory-slot-creator',
  templateUrl: './inventory-slot-creator.component.html',
  styleUrl: './inventory-slot-creator.component.scss'
})
export class InventorySlotCreatorComponent implements OnInit{

  slotNameCtrl = new FormControl('', [Validators.required]);

  constructor(private dialogRef: MatDialogRef<InventorySlotCreatorComponent>,
              @Inject(MAT_DIALOG_DATA) public data: InventorySlot | undefined) {

  }

  ngOnInit() {
    if(this.data != undefined) {
      this.slotNameCtrl.setValue(this.data.slotName);
    }
  }

  submit() {
    if(this.data != undefined) {
      this.data.slotName = this.slotNameCtrl.value!;
      this.dialogRef.close(this.data);
    } else {
      this.dialogRef.close(new InventorySlot(this.slotNameCtrl.value!))
    }

  }

  cancel() {
    this.dialogRef.close()
  }
}
