import {Component, Input} from '@angular/core';
import {Character} from "../../../project/game-model/characters/Character";
import {ItemGroup} from "../../../project/game-model/inventory/ItemGroup";
import {InventorySlot} from "../../../project/game-model/inventory/intentory-slots/InventorySlot";
import {MatDialog} from "@angular/material/dialog";
import {InventorySlotCreatorComponent} from "./inventory-slot-creator/inventory-slot-creator.component";

@Component({
  selector: 'app-inventory-slot-editor',
  templateUrl: './inventory-slot-editor.component.html',
  styleUrl: './inventory-slot-editor.component.scss'
})
export class InventorySlotEditorComponent {

  @Input() character: Character | undefined
  @Input() itemgroups: ItemGroup[] = []

  constructor(private dialog: MatDialog)  {
  }

  addInventorySlot() {
    const dialogRef = this.dialog.open(InventorySlotCreatorComponent, {
      minWidth: "400px"
    })

    dialogRef.afterClosed().subscribe(res => {
      if(res != undefined) {
        this.character!.inventorySlots.push(res)
      }
    })
  }

  renameInventorySlot(inventorySlot: InventorySlot) {
   this.dialog.open(InventorySlotCreatorComponent, {
      minWidth: "400px",
      data: inventorySlot
    })
  }

  deleteInventorySlot(inventorySlot: InventorySlot) {
    this.character!.removeInventorySlot(inventorySlot)
  }
}
